> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Swap template data sources

POST https://api.sigmacomputing.com/v2/templates/{templateId}/swapSources
Content-Type: application/json

Swap the data sources used by a workbook template. You can swap from one connection to another, and/or from one dataset to another.

  ### Usage notes
  - Retrieve the **templateId** by calling the [/v2/templates](https://help.sigmacomputing.com/reference/list-templates) endpoint.
  - Retrieve the **connectionId** to use as the **toId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
  - To map the sources of a specific element, you can use the table or dataset ID:

    - Retrieve the **fromId** for a specific data element by calling the [/v2/workbooks/{workbookId}/lineage/elements/{elementId}](https://help.sigmacomputing.com/reference/list-lineage) endpoint and using the `source` key from the response, which looks like `inode-2PBoXx3UabchxF1F3l07kE`. The ID is everything after `inode-`.
    - Retrieve table and dataset IDs by calling the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint. Use the `typeFilters` option to filter for table and dataset files. Use `id` field in the response as the `fromId` or `toId`, as relevant.
    

Reference: https://help.sigmacomputing.com/reference/source-swap-template

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/templates/{templateId}/swapSources:
    post:
      operationId: sourceSwapTemplate
      summary: Swap template data sources
      description: >-
        Swap the data sources used by a workbook template. You can swap from one
        connection to another, and/or from one dataset to another.

          ### Usage notes
          - Retrieve the **templateId** by calling the [/v2/templates](https://help.sigmacomputing.com/reference/list-templates) endpoint.
          - Retrieve the **connectionId** to use as the **toId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
          - To map the sources of a specific element, you can use the table or dataset ID:

            - Retrieve the **fromId** for a specific data element by calling the [/v2/workbooks/{workbookId}/lineage/elements/{elementId}](https://help.sigmacomputing.com/reference/list-lineage) endpoint and using the `source` key from the response, which looks like `inode-2PBoXx3UabchxF1F3l07kE`. The ID is everything after `inode-`.
            - Retrieve table and dataset IDs by calling the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint. Use the `typeFilters` option to filter for table and dataset files. Use `id` field in the response as the `fromId` or `toId`, as relevant.
            
      tags:
        - Templates
      parameters:
        - name: templateId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/templates_sourceSwapTemplate_Response_200'
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                sourceMapping:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItems
                connectionMapping:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems
                copyInputTableData:
                  type: boolean
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems:
      type: object
      properties:
        fromMetric:
          type: string
          description: Metric in the data source.
        toMetric:
          type: string
          description: Metric in the data source.
      required:
        - fromMetric
        - toMetric
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn:
      oneOf:
        - type: string
        - type: array
          items:
            type: string
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn:
      oneOf:
        - type: string
        - type: array
          items:
            type: string
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems:
      type: object
      properties:
        fromColumn:
          $ref: >-
            #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn
        toColumn:
          $ref: >-
            #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn
      required:
        - fromColumn
        - toColumn
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItems:
      type: object
      properties:
        fromId:
          type: string
          description: ID of the dataset (deprecated) or table to swap from.
        toId:
          type: string
          description: ID of the dataset (deprecated) or table to swap to.
        metricMapping:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems
        columnMapping:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems
      required:
        - fromId
        - toId
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaSourceMappingItems
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems:
      type: object
      properties:
        fromPath:
          type: array
          items:
            type: string
          description: Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
        toPath:
          type: array
          items:
            type: string
          description: Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
      required:
        - fromPath
        - toPath
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems
    V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems:
      type: object
      properties:
        fromId:
          type: string
          description: ID of the connection to swap from.
        toId:
          type: string
          description: ID of the connection to swap to.
        swapTables:
          type: boolean
          description: Whether to swap all tables in the connection
        paths:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItemsPathsItems
      required:
        - fromId
        - toId
      title: >-
        V2TemplatesTemplateIdSwapSourcesPostRequestBodyContentApplicationJsonSchemaConnectionMappingItems
    templates_sourceSwapTemplate_Response_200:
      type: object
      properties:
        unswappedSources:
          type: array
          items:
            type: string
          description: IDs of sources in the workbook that were not swapped.
        unswappedConnections:
          type: array
          items:
            type: string
          description: IDs of custom SQL connections in the workbook that were not swapped.
      required:
        - unswappedSources
        - unswappedConnections
      title: templates_sourceSwapTemplate_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "unswappedSources": [
    "dataset-7f3a9c2d4b1e4a6f9d8c7b2a"
  ],
  "unswappedConnections": [
    "conn-12345abcde67890fghij"
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/templates/templateId/swapSources"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/templates/templateId/swapSources';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/templates/templateId/swapSources"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/templates/templateId/swapSources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/templates/templateId/swapSources")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/templates/templateId/swapSources', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/templates/templateId/swapSources");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/templates/templateId/swapSources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```